<template>
  <div class="champions">
    <div class="champions_header">
      <div class="champions_profile">
        <div class="flex flex_column flex-center">
          <div class="champions_profile-title">{{$t('champions.eosName')}}</div>
          <div class="champions_profile-name"><span v-if="accountName==='no account'">{{$t('common.noAccount')}}</span><span v-else>{{accountName}}</span></div>
        </div>
        <div class="flex">
          <div class="champions_profile-rating">
            <div class="champions_profile-rating-title">{{$t('common.bonus')}}</div>
            <div class="champions_profile-rating-number">
              <img
                src="~/static/icons/eos_logo_small.png"
                alt="">
              <span class="color-green">{{bonus}}</span></div>
          </div>
          <div class="champions_profile-rating">
            <div class="champions_profile-rating-title">{{$t('common.rating')}}</div>
            <div class="champions_profile-rating-number">{{rating}}</div>
          </div>
          <div
            class="flex flex-middle champions_profile-icon">
            <v-popover
              offset="16"
              placement="top-left">
              <img
                src="~/static/icons/information.png"
                alt="">
              <template slot="popover">
                {{$t('champions.helper')}}
              </template>
            </v-popover>
          </div>
        </div>
      </div>
    </div>
    <Card>
      <div class="champions_body">
        <div class="champions_body-filters champions_body-row">
          <div
            class="champions_body-filters-left champions_body-col">
            <button
              @click="setFilter(true)"
              :class="{active: today}"
              style="margin: 0px 5px; min-height: 38px; flex:1;"
              class="flat_btn">
              {{$t('times.day')}}
            </button>
            <TheTimer type="day"></TheTimer>
          </div>
          <div
            class="champions_body-filters-right champions_body-col">
            <button
              @click="setFilter(false)"
              :class="{active: !today}"
              style="margin: 0px 5px; min-height: 38px; flex:1;"
              class="flat_btn">{{$t('times.month')}}
            </button>
            <TheTimer type="month"></TheTimer>
          </div>
        </div>
        <div class="champions_body-inner-title">
          <div class="champions_body-col">{{$t('champions.eosName')}}</div>
          <div class="champions_body-col">{{$t('champions.totalWin')}}</div>
        </div>
        <div
          class="champions_body-inner"
          ref="container">
          <div
            v-if="!topData.length"
            class="flex flex-center flex-middle"
            style="min-height: 117px;">
            {{$t('champions.empty')}}
          </div>
          <div
            class="champions_body-row"
            v-for="(item, key) in topData"
            :class="{me: accountName===item.username.toLowerCase()}"
            :key="'key-'+key">
            <div class="champions_body-col">{{key+1}}. {{item.username}} <img
              v-if="accountName===item.username.toLowerCase()"
              src="~/static/icons/championStar.svg"
              class="champions_body-col-star"
              alt="">
            </div>
            <div class="champions_body-col">{{item.total_win}} EOS</div>
          </div>
        </div>
      </div>
    </Card>
    <Card v-if="data.length>10">
      <div class="champions_body">
        <div
          class="champions_body-inner"
          ref="container">
          <div
            class="champions_body-row"
            v-for="(item, key) in data"
            :class="{me: accountName===item.username.toLowerCase()}"
            :key="'key-'+key">
            <div class="champions_body-col">{{key+11}}. {{item.username}} <img
              v-if="accountName===item.username.toLowerCase()"
              src="~/static/icons/championStar.svg"
              class="champions_body-col-star"
              alt="">
            </div>
            <div class="champions_body-col">{{item.total_win}} EOS</div>
          </div>
          <div
            class="champions_body-row pt-10 pb-10 flex-center"
            v-show="loading">
            <LoadingLabel></LoadingLabel>
          </div>
        </div>
      </div>
    </Card>
  </div>
</template>

<script>
  import Card from '~/components/fullHistory/components/Card';
  import {getScrollPercent} from "~/components/utils";
  import debounce from 'lodash.debounce';
  import {mapState} from 'vuex'
  import LoadingLabel from '~/components/UI/LoadingLabel';
  import TheTimer from './TheTimer';

  export default {
    name: "champions_stats",
    data() {
      return {
        limit: 20,
        offset: 0,
        page: 1,
        loading: false,
        gq: () => {
        },
        today: true,
        lastScrollY: 0
      }
    },
    computed: {
      ...mapState({
        bonus: state => state.players.bonus,
        rating: state => state.players.rating,
        accountName: state => state.wallet.accountName.toLowerCase(),
        data: state => state.players.data.slice(10),
        topData: state => state.players.data.slice(0, 10)
      })
    },
    components: {
      Card,
      LoadingLabel,
      TheTimer
    },
    methods: {
      setFilter(today) {
        this.today = today;
        this.page = 1;
        this.lastScrollY = 0;
        today ? this.getData(today) : this.getData();
        this.$store.dispatch('players/fetchPlayerRating', {today: this.today})
      },
      getData(today = undefined) {
        this.$store.dispatch('players/fetch', {
          order: today ? 'asc' : 'desc',
          today,
          flush: this.page === 1,
          offset: this.limit * (this.page - 1),
          limit: this.limit
        }).then(res => {
          this.loading = false;
        }).catch(e => {
          this.loading = false;
        });
      }
    },
    mounted() {
      this.gq = debounce(this.getData, 800);
      this.getData(true);
      this.$store.dispatch('players/fetchPlayerRating', {today: this.today});
      this.$onWrapperScroll.flush();
      this.$onWrapperScroll.onScroll((e) => {
        if (getScrollPercent(this.$onWrapperScroll.container) > 80 && e.target.scrollTop > this.lastScrollY && !this.loading) {
          this.lastScrollY = e.target.scrollTop;
          this.loading = true;
          this.page += 1;
          this.$nextTick(_ => {
            this.gq(this.today);
          });
        }
      });
    }
  }
</script>
